import type { BaseContract, BigNumberish, BytesLike, FunctionFragment, Result, Interface, EventFragment, AddressLike, ContractRunner, ContractMethod, Listener } from "ethers";
import type { TypedContractEvent, TypedDeferredTopicFilter, TypedEventLog, TypedLogDescription, TypedListener, TypedContractMethod } from "../../common";
export interface FeedPriceOracleInterface extends Interface {
    getFunction(nameOrSignature: "acceptOwnership" | "adapterFeeds" | "chainlinkFeeds" | "fixedPrices" | "getFixedPrice" | "getPrice" | "getUnderlyingPrice" | "getUnderlyingPrices" | "isPriceOracle" | "layerbankFeeds" | "mainSource" | "nativeAsset" | "nativeMarket" | "owner" | "pendingOwner" | "pendleFeeds" | "pendlePtOracle" | "pythFeeds" | "pythOracle" | "redstoneFeeds" | "removeAdapterFeed" | "removeBalancerFeed" | "removeChainlinkFeed" | "removeFixedPrice" | "removeKodiakIslandFeed" | "removeLayerbankFeed" | "removePendleFeed" | "removePythFeed" | "removeRedstoneFeed" | "removeUniswapV2Feed" | "renounceOwnership" | "setAdapterFeed" | "setBalancerFeed" | "setChainlinkFeed" | "setFixedPrice" | "setKodiakIslandFeed" | "setLayerbankFeed" | "setMainSource" | "setPendleFeed" | "setPendlePtOracle" | "setPythFeed" | "setPythOracle" | "setRedStoneFeed" | "setUniswapV2Feed" | "transferOwnership"): FunctionFragment;
    getEvent(nameOrSignatureOrTopic: "NewFeed" | "NewPendlePtOracle" | "NewPythOracle" | "OwnershipTransferStarted" | "OwnershipTransferred"): EventFragment;
    encodeFunctionData(functionFragment: "acceptOwnership", values?: undefined): string;
    encodeFunctionData(functionFragment: "adapterFeeds", values: [AddressLike]): string;
    encodeFunctionData(functionFragment: "chainlinkFeeds", values: [AddressLike]): string;
    encodeFunctionData(functionFragment: "fixedPrices", values: [AddressLike]): string;
    encodeFunctionData(functionFragment: "getFixedPrice", values: [AddressLike]): string;
    encodeFunctionData(functionFragment: "getPrice", values: [AddressLike]): string;
    encodeFunctionData(functionFragment: "getUnderlyingPrice", values: [AddressLike]): string;
    encodeFunctionData(functionFragment: "getUnderlyingPrices", values: [AddressLike[]]): string;
    encodeFunctionData(functionFragment: "isPriceOracle", values?: undefined): string;
    encodeFunctionData(functionFragment: "layerbankFeeds", values: [AddressLike]): string;
    encodeFunctionData(functionFragment: "mainSource", values: [AddressLike]): string;
    encodeFunctionData(functionFragment: "nativeAsset", values?: undefined): string;
    encodeFunctionData(functionFragment: "nativeMarket", values?: undefined): string;
    encodeFunctionData(functionFragment: "owner", values?: undefined): string;
    encodeFunctionData(functionFragment: "pendingOwner", values?: undefined): string;
    encodeFunctionData(functionFragment: "pendleFeeds", values: [AddressLike]): string;
    encodeFunctionData(functionFragment: "pendlePtOracle", values?: undefined): string;
    encodeFunctionData(functionFragment: "pythFeeds", values: [AddressLike]): string;
    encodeFunctionData(functionFragment: "pythOracle", values?: undefined): string;
    encodeFunctionData(functionFragment: "redstoneFeeds", values: [AddressLike]): string;
    encodeFunctionData(functionFragment: "removeAdapterFeed", values: [AddressLike]): string;
    encodeFunctionData(functionFragment: "removeBalancerFeed", values: [AddressLike]): string;
    encodeFunctionData(functionFragment: "removeChainlinkFeed", values: [AddressLike]): string;
    encodeFunctionData(functionFragment: "removeFixedPrice", values: [AddressLike]): string;
    encodeFunctionData(functionFragment: "removeKodiakIslandFeed", values: [AddressLike]): string;
    encodeFunctionData(functionFragment: "removeLayerbankFeed", values: [AddressLike]): string;
    encodeFunctionData(functionFragment: "removePendleFeed", values: [AddressLike]): string;
    encodeFunctionData(functionFragment: "removePythFeed", values: [AddressLike]): string;
    encodeFunctionData(functionFragment: "removeRedstoneFeed", values: [AddressLike]): string;
    encodeFunctionData(functionFragment: "removeUniswapV2Feed", values: [AddressLike]): string;
    encodeFunctionData(functionFragment: "renounceOwnership", values?: undefined): string;
    encodeFunctionData(functionFragment: "setAdapterFeed", values: [AddressLike, AddressLike, AddressLike]): string;
    encodeFunctionData(functionFragment: "setBalancerFeed", values: [AddressLike]): string;
    encodeFunctionData(functionFragment: "setChainlinkFeed", values: [AddressLike, AddressLike, BigNumberish, AddressLike]): string;
    encodeFunctionData(functionFragment: "setFixedPrice", values: [AddressLike, BigNumberish]): string;
    encodeFunctionData(functionFragment: "setKodiakIslandFeed", values: [AddressLike]): string;
    encodeFunctionData(functionFragment: "setLayerbankFeed", values: [AddressLike, AddressLike, AddressLike]): string;
    encodeFunctionData(functionFragment: "setMainSource", values: [AddressLike, BigNumberish]): string;
    encodeFunctionData(functionFragment: "setPendleFeed", values: [AddressLike, AddressLike, BigNumberish, AddressLike]): string;
    encodeFunctionData(functionFragment: "setPendlePtOracle", values: [AddressLike]): string;
    encodeFunctionData(functionFragment: "setPythFeed", values: [AddressLike, BigNumberish, BytesLike, AddressLike]): string;
    encodeFunctionData(functionFragment: "setPythOracle", values: [AddressLike]): string;
    encodeFunctionData(functionFragment: "setRedStoneFeed", values: [AddressLike, AddressLike, BigNumberish, AddressLike]): string;
    encodeFunctionData(functionFragment: "setUniswapV2Feed", values: [AddressLike]): string;
    encodeFunctionData(functionFragment: "transferOwnership", values: [AddressLike]): string;
    decodeFunctionResult(functionFragment: "acceptOwnership", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "adapterFeeds", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "chainlinkFeeds", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "fixedPrices", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getFixedPrice", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getPrice", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getUnderlyingPrice", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getUnderlyingPrices", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "isPriceOracle", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "layerbankFeeds", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "mainSource", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "nativeAsset", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "nativeMarket", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "owner", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "pendingOwner", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "pendleFeeds", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "pendlePtOracle", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "pythFeeds", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "pythOracle", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "redstoneFeeds", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "removeAdapterFeed", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "removeBalancerFeed", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "removeChainlinkFeed", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "removeFixedPrice", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "removeKodiakIslandFeed", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "removeLayerbankFeed", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "removePendleFeed", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "removePythFeed", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "removeRedstoneFeed", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "removeUniswapV2Feed", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "renounceOwnership", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "setAdapterFeed", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "setBalancerFeed", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "setChainlinkFeed", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "setFixedPrice", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "setKodiakIslandFeed", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "setLayerbankFeed", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "setMainSource", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "setPendleFeed", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "setPendlePtOracle", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "setPythFeed", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "setPythOracle", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "setRedStoneFeed", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "setUniswapV2Feed", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "transferOwnership", data: BytesLike): Result;
}
export declare namespace NewFeedEvent {
    type InputTuple = [
        asset: AddressLike,
        source: BigNumberish,
        feedDecimals: BigNumberish,
        maxStalePeriod: BigNumberish,
        metadata: BytesLike
    ];
    type OutputTuple = [
        asset: string,
        source: bigint,
        feedDecimals: bigint,
        maxStalePeriod: bigint,
        metadata: string
    ];
    interface OutputObject {
        asset: string;
        source: bigint;
        feedDecimals: bigint;
        maxStalePeriod: bigint;
        metadata: string;
    }
    type Event = TypedContractEvent<InputTuple, OutputTuple, OutputObject>;
    type Filter = TypedDeferredTopicFilter<Event>;
    type Log = TypedEventLog<Event>;
    type LogDescription = TypedLogDescription<Event>;
}
export declare namespace NewPendlePtOracleEvent {
    type InputTuple = [oldValue: AddressLike, newValue: AddressLike];
    type OutputTuple = [oldValue: string, newValue: string];
    interface OutputObject {
        oldValue: string;
        newValue: string;
    }
    type Event = TypedContractEvent<InputTuple, OutputTuple, OutputObject>;
    type Filter = TypedDeferredTopicFilter<Event>;
    type Log = TypedEventLog<Event>;
    type LogDescription = TypedLogDescription<Event>;
}
export declare namespace NewPythOracleEvent {
    type InputTuple = [oldValue: AddressLike, newValue: AddressLike];
    type OutputTuple = [oldValue: string, newValue: string];
    interface OutputObject {
        oldValue: string;
        newValue: string;
    }
    type Event = TypedContractEvent<InputTuple, OutputTuple, OutputObject>;
    type Filter = TypedDeferredTopicFilter<Event>;
    type Log = TypedEventLog<Event>;
    type LogDescription = TypedLogDescription<Event>;
}
export declare namespace OwnershipTransferStartedEvent {
    type InputTuple = [previousOwner: AddressLike, newOwner: AddressLike];
    type OutputTuple = [previousOwner: string, newOwner: string];
    interface OutputObject {
        previousOwner: string;
        newOwner: string;
    }
    type Event = TypedContractEvent<InputTuple, OutputTuple, OutputObject>;
    type Filter = TypedDeferredTopicFilter<Event>;
    type Log = TypedEventLog<Event>;
    type LogDescription = TypedLogDescription<Event>;
}
export declare namespace OwnershipTransferredEvent {
    type InputTuple = [previousOwner: AddressLike, newOwner: AddressLike];
    type OutputTuple = [previousOwner: string, newOwner: string];
    interface OutputObject {
        previousOwner: string;
        newOwner: string;
    }
    type Event = TypedContractEvent<InputTuple, OutputTuple, OutputObject>;
    type Filter = TypedDeferredTopicFilter<Event>;
    type Log = TypedEventLog<Event>;
    type LogDescription = TypedLogDescription<Event>;
}
export interface FeedPriceOracle extends BaseContract {
    connect(runner?: ContractRunner | null): FeedPriceOracle;
    waitForDeployment(): Promise<this>;
    interface: FeedPriceOracleInterface;
    queryFilter<TCEvent extends TypedContractEvent>(event: TCEvent, fromBlockOrBlockhash?: string | number | undefined, toBlock?: string | number | undefined): Promise<Array<TypedEventLog<TCEvent>>>;
    queryFilter<TCEvent extends TypedContractEvent>(filter: TypedDeferredTopicFilter<TCEvent>, fromBlockOrBlockhash?: string | number | undefined, toBlock?: string | number | undefined): Promise<Array<TypedEventLog<TCEvent>>>;
    on<TCEvent extends TypedContractEvent>(event: TCEvent, listener: TypedListener<TCEvent>): Promise<this>;
    on<TCEvent extends TypedContractEvent>(filter: TypedDeferredTopicFilter<TCEvent>, listener: TypedListener<TCEvent>): Promise<this>;
    once<TCEvent extends TypedContractEvent>(event: TCEvent, listener: TypedListener<TCEvent>): Promise<this>;
    once<TCEvent extends TypedContractEvent>(filter: TypedDeferredTopicFilter<TCEvent>, listener: TypedListener<TCEvent>): Promise<this>;
    listeners<TCEvent extends TypedContractEvent>(event: TCEvent): Promise<Array<TypedListener<TCEvent>>>;
    listeners(eventName?: string): Promise<Array<Listener>>;
    removeAllListeners<TCEvent extends TypedContractEvent>(event?: TCEvent): Promise<this>;
    acceptOwnership: TypedContractMethod<[], [void], "nonpayable">;
    adapterFeeds: TypedContractMethod<[
        arg0: AddressLike
    ], [
        [string, string] & {
            adapterAddr: string;
            denominator: string;
        }
    ], "view">;
    chainlinkFeeds: TypedContractMethod<[
        arg0: AddressLike
    ], [
        [
            string,
            string,
            bigint,
            bigint
        ] & {
            feedAddr: string;
            denominator: string;
            feedDecimals: bigint;
            maxStalePeriod: bigint;
        }
    ], "view">;
    fixedPrices: TypedContractMethod<[arg0: AddressLike], [bigint], "view">;
    getFixedPrice: TypedContractMethod<[asset: AddressLike], [bigint], "view">;
    getPrice: TypedContractMethod<[asset: AddressLike], [bigint], "view">;
    getUnderlyingPrice: TypedContractMethod<[
        ctoken: AddressLike
    ], [
        bigint
    ], "view">;
    getUnderlyingPrices: TypedContractMethod<[
        cTokens: AddressLike[]
    ], [
        bigint[]
    ], "view">;
    isPriceOracle: TypedContractMethod<[], [boolean], "view">;
    layerbankFeeds: TypedContractMethod<[
        arg0: AddressLike
    ], [
        [string, string] & {
            feedAddr: string;
            feedAssetAddr: string;
        }
    ], "view">;
    mainSource: TypedContractMethod<[arg0: AddressLike], [bigint], "view">;
    nativeAsset: TypedContractMethod<[], [string], "view">;
    nativeMarket: TypedContractMethod<[], [string], "view">;
    owner: TypedContractMethod<[], [string], "view">;
    pendingOwner: TypedContractMethod<[], [string], "view">;
    pendleFeeds: TypedContractMethod<[
        arg0: AddressLike
    ], [
        [
            string,
            string,
            bigint
        ] & {
            market: string;
            yieldToken: string;
            twapDuration: bigint;
        }
    ], "view">;
    pendlePtOracle: TypedContractMethod<[], [string], "view">;
    pythFeeds: TypedContractMethod<[
        arg0: AddressLike
    ], [
        [
            string,
            bigint,
            string
        ] & {
            feedId: string;
            maxStalePeriod: bigint;
            denominator: string;
        }
    ], "view">;
    pythOracle: TypedContractMethod<[], [string], "view">;
    redstoneFeeds: TypedContractMethod<[
        arg0: AddressLike
    ], [
        [
            string,
            string,
            bigint,
            bigint
        ] & {
            feedAddr: string;
            denominator: string;
            feedDecimals: bigint;
            maxStalePeriod: bigint;
        }
    ], "view">;
    removeAdapterFeed: TypedContractMethod<[
        asset: AddressLike
    ], [
        void
    ], "nonpayable">;
    removeBalancerFeed: TypedContractMethod<[
        asset: AddressLike
    ], [
        void
    ], "nonpayable">;
    removeChainlinkFeed: TypedContractMethod<[
        asset: AddressLike
    ], [
        void
    ], "nonpayable">;
    removeFixedPrice: TypedContractMethod<[
        asset: AddressLike
    ], [
        void
    ], "nonpayable">;
    removeKodiakIslandFeed: TypedContractMethod<[
        asset: AddressLike
    ], [
        void
    ], "nonpayable">;
    removeLayerbankFeed: TypedContractMethod<[
        asset: AddressLike
    ], [
        void
    ], "nonpayable">;
    removePendleFeed: TypedContractMethod<[
        asset: AddressLike
    ], [
        void
    ], "nonpayable">;
    removePythFeed: TypedContractMethod<[
        asset: AddressLike
    ], [
        void
    ], "nonpayable">;
    removeRedstoneFeed: TypedContractMethod<[
        asset: AddressLike
    ], [
        void
    ], "nonpayable">;
    removeUniswapV2Feed: TypedContractMethod<[
        asset: AddressLike
    ], [
        void
    ], "nonpayable">;
    renounceOwnership: TypedContractMethod<[], [void], "nonpayable">;
    setAdapterFeed: TypedContractMethod<[
        asset: AddressLike,
        adapterAddr: AddressLike,
        denominator: AddressLike
    ], [
        void
    ], "nonpayable">;
    setBalancerFeed: TypedContractMethod<[
        asset: AddressLike
    ], [
        void
    ], "nonpayable">;
    setChainlinkFeed: TypedContractMethod<[
        asset: AddressLike,
        feedAddr: AddressLike,
        maxStalePeriod: BigNumberish,
        denominator: AddressLike
    ], [
        void
    ], "nonpayable">;
    setFixedPrice: TypedContractMethod<[
        asset: AddressLike,
        price: BigNumberish
    ], [
        void
    ], "nonpayable">;
    setKodiakIslandFeed: TypedContractMethod<[
        asset: AddressLike
    ], [
        void
    ], "nonpayable">;
    setLayerbankFeed: TypedContractMethod<[
        asset: AddressLike,
        feedAddr: AddressLike,
        feedAssetAddr: AddressLike
    ], [
        void
    ], "nonpayable">;
    setMainSource: TypedContractMethod<[
        asset: AddressLike,
        source: BigNumberish
    ], [
        void
    ], "nonpayable">;
    setPendleFeed: TypedContractMethod<[
        asset: AddressLike,
        market: AddressLike,
        twapDuration: BigNumberish,
        yieldToken: AddressLike
    ], [
        void
    ], "nonpayable">;
    setPendlePtOracle: TypedContractMethod<[
        pendlePtOracle_: AddressLike
    ], [
        void
    ], "nonpayable">;
    setPythFeed: TypedContractMethod<[
        asset: AddressLike,
        maxStalePeriod: BigNumberish,
        feedId: BytesLike,
        denominator: AddressLike
    ], [
        void
    ], "nonpayable">;
    setPythOracle: TypedContractMethod<[
        pythOracle_: AddressLike
    ], [
        void
    ], "nonpayable">;
    setRedStoneFeed: TypedContractMethod<[
        asset: AddressLike,
        feedAddr: AddressLike,
        maxStalePeriod: BigNumberish,
        denominator: AddressLike
    ], [
        void
    ], "nonpayable">;
    setUniswapV2Feed: TypedContractMethod<[
        asset: AddressLike
    ], [
        void
    ], "nonpayable">;
    transferOwnership: TypedContractMethod<[
        newOwner: AddressLike
    ], [
        void
    ], "nonpayable">;
    getFunction<T extends ContractMethod = ContractMethod>(key: string | FunctionFragment): T;
    getFunction(nameOrSignature: "acceptOwnership"): TypedContractMethod<[], [void], "nonpayable">;
    getFunction(nameOrSignature: "adapterFeeds"): TypedContractMethod<[
        arg0: AddressLike
    ], [
        [string, string] & {
            adapterAddr: string;
            denominator: string;
        }
    ], "view">;
    getFunction(nameOrSignature: "chainlinkFeeds"): TypedContractMethod<[
        arg0: AddressLike
    ], [
        [
            string,
            string,
            bigint,
            bigint
        ] & {
            feedAddr: string;
            denominator: string;
            feedDecimals: bigint;
            maxStalePeriod: bigint;
        }
    ], "view">;
    getFunction(nameOrSignature: "fixedPrices"): TypedContractMethod<[arg0: AddressLike], [bigint], "view">;
    getFunction(nameOrSignature: "getFixedPrice"): TypedContractMethod<[asset: AddressLike], [bigint], "view">;
    getFunction(nameOrSignature: "getPrice"): TypedContractMethod<[asset: AddressLike], [bigint], "view">;
    getFunction(nameOrSignature: "getUnderlyingPrice"): TypedContractMethod<[ctoken: AddressLike], [bigint], "view">;
    getFunction(nameOrSignature: "getUnderlyingPrices"): TypedContractMethod<[cTokens: AddressLike[]], [bigint[]], "view">;
    getFunction(nameOrSignature: "isPriceOracle"): TypedContractMethod<[], [boolean], "view">;
    getFunction(nameOrSignature: "layerbankFeeds"): TypedContractMethod<[
        arg0: AddressLike
    ], [
        [string, string] & {
            feedAddr: string;
            feedAssetAddr: string;
        }
    ], "view">;
    getFunction(nameOrSignature: "mainSource"): TypedContractMethod<[arg0: AddressLike], [bigint], "view">;
    getFunction(nameOrSignature: "nativeAsset"): TypedContractMethod<[], [string], "view">;
    getFunction(nameOrSignature: "nativeMarket"): TypedContractMethod<[], [string], "view">;
    getFunction(nameOrSignature: "owner"): TypedContractMethod<[], [string], "view">;
    getFunction(nameOrSignature: "pendingOwner"): TypedContractMethod<[], [string], "view">;
    getFunction(nameOrSignature: "pendleFeeds"): TypedContractMethod<[
        arg0: AddressLike
    ], [
        [
            string,
            string,
            bigint
        ] & {
            market: string;
            yieldToken: string;
            twapDuration: bigint;
        }
    ], "view">;
    getFunction(nameOrSignature: "pendlePtOracle"): TypedContractMethod<[], [string], "view">;
    getFunction(nameOrSignature: "pythFeeds"): TypedContractMethod<[
        arg0: AddressLike
    ], [
        [
            string,
            bigint,
            string
        ] & {
            feedId: string;
            maxStalePeriod: bigint;
            denominator: string;
        }
    ], "view">;
    getFunction(nameOrSignature: "pythOracle"): TypedContractMethod<[], [string], "view">;
    getFunction(nameOrSignature: "redstoneFeeds"): TypedContractMethod<[
        arg0: AddressLike
    ], [
        [
            string,
            string,
            bigint,
            bigint
        ] & {
            feedAddr: string;
            denominator: string;
            feedDecimals: bigint;
            maxStalePeriod: bigint;
        }
    ], "view">;
    getFunction(nameOrSignature: "removeAdapterFeed"): TypedContractMethod<[asset: AddressLike], [void], "nonpayable">;
    getFunction(nameOrSignature: "removeBalancerFeed"): TypedContractMethod<[asset: AddressLike], [void], "nonpayable">;
    getFunction(nameOrSignature: "removeChainlinkFeed"): TypedContractMethod<[asset: AddressLike], [void], "nonpayable">;
    getFunction(nameOrSignature: "removeFixedPrice"): TypedContractMethod<[asset: AddressLike], [void], "nonpayable">;
    getFunction(nameOrSignature: "removeKodiakIslandFeed"): TypedContractMethod<[asset: AddressLike], [void], "nonpayable">;
    getFunction(nameOrSignature: "removeLayerbankFeed"): TypedContractMethod<[asset: AddressLike], [void], "nonpayable">;
    getFunction(nameOrSignature: "removePendleFeed"): TypedContractMethod<[asset: AddressLike], [void], "nonpayable">;
    getFunction(nameOrSignature: "removePythFeed"): TypedContractMethod<[asset: AddressLike], [void], "nonpayable">;
    getFunction(nameOrSignature: "removeRedstoneFeed"): TypedContractMethod<[asset: AddressLike], [void], "nonpayable">;
    getFunction(nameOrSignature: "removeUniswapV2Feed"): TypedContractMethod<[asset: AddressLike], [void], "nonpayable">;
    getFunction(nameOrSignature: "renounceOwnership"): TypedContractMethod<[], [void], "nonpayable">;
    getFunction(nameOrSignature: "setAdapterFeed"): TypedContractMethod<[
        asset: AddressLike,
        adapterAddr: AddressLike,
        denominator: AddressLike
    ], [
        void
    ], "nonpayable">;
    getFunction(nameOrSignature: "setBalancerFeed"): TypedContractMethod<[asset: AddressLike], [void], "nonpayable">;
    getFunction(nameOrSignature: "setChainlinkFeed"): TypedContractMethod<[
        asset: AddressLike,
        feedAddr: AddressLike,
        maxStalePeriod: BigNumberish,
        denominator: AddressLike
    ], [
        void
    ], "nonpayable">;
    getFunction(nameOrSignature: "setFixedPrice"): TypedContractMethod<[
        asset: AddressLike,
        price: BigNumberish
    ], [
        void
    ], "nonpayable">;
    getFunction(nameOrSignature: "setKodiakIslandFeed"): TypedContractMethod<[asset: AddressLike], [void], "nonpayable">;
    getFunction(nameOrSignature: "setLayerbankFeed"): TypedContractMethod<[
        asset: AddressLike,
        feedAddr: AddressLike,
        feedAssetAddr: AddressLike
    ], [
        void
    ], "nonpayable">;
    getFunction(nameOrSignature: "setMainSource"): TypedContractMethod<[
        asset: AddressLike,
        source: BigNumberish
    ], [
        void
    ], "nonpayable">;
    getFunction(nameOrSignature: "setPendleFeed"): TypedContractMethod<[
        asset: AddressLike,
        market: AddressLike,
        twapDuration: BigNumberish,
        yieldToken: AddressLike
    ], [
        void
    ], "nonpayable">;
    getFunction(nameOrSignature: "setPendlePtOracle"): TypedContractMethod<[pendlePtOracle_: AddressLike], [void], "nonpayable">;
    getFunction(nameOrSignature: "setPythFeed"): TypedContractMethod<[
        asset: AddressLike,
        maxStalePeriod: BigNumberish,
        feedId: BytesLike,
        denominator: AddressLike
    ], [
        void
    ], "nonpayable">;
    getFunction(nameOrSignature: "setPythOracle"): TypedContractMethod<[pythOracle_: AddressLike], [void], "nonpayable">;
    getFunction(nameOrSignature: "setRedStoneFeed"): TypedContractMethod<[
        asset: AddressLike,
        feedAddr: AddressLike,
        maxStalePeriod: BigNumberish,
        denominator: AddressLike
    ], [
        void
    ], "nonpayable">;
    getFunction(nameOrSignature: "setUniswapV2Feed"): TypedContractMethod<[asset: AddressLike], [void], "nonpayable">;
    getFunction(nameOrSignature: "transferOwnership"): TypedContractMethod<[newOwner: AddressLike], [void], "nonpayable">;
    getEvent(key: "NewFeed"): TypedContractEvent<NewFeedEvent.InputTuple, NewFeedEvent.OutputTuple, NewFeedEvent.OutputObject>;
    getEvent(key: "NewPendlePtOracle"): TypedContractEvent<NewPendlePtOracleEvent.InputTuple, NewPendlePtOracleEvent.OutputTuple, NewPendlePtOracleEvent.OutputObject>;
    getEvent(key: "NewPythOracle"): TypedContractEvent<NewPythOracleEvent.InputTuple, NewPythOracleEvent.OutputTuple, NewPythOracleEvent.OutputObject>;
    getEvent(key: "OwnershipTransferStarted"): TypedContractEvent<OwnershipTransferStartedEvent.InputTuple, OwnershipTransferStartedEvent.OutputTuple, OwnershipTransferStartedEvent.OutputObject>;
    getEvent(key: "OwnershipTransferred"): TypedContractEvent<OwnershipTransferredEvent.InputTuple, OwnershipTransferredEvent.OutputTuple, OwnershipTransferredEvent.OutputObject>;
    filters: {
        "NewFeed(address,uint8,uint8,uint32,bytes32)": TypedContractEvent<NewFeedEvent.InputTuple, NewFeedEvent.OutputTuple, NewFeedEvent.OutputObject>;
        NewFeed: TypedContractEvent<NewFeedEvent.InputTuple, NewFeedEvent.OutputTuple, NewFeedEvent.OutputObject>;
        "NewPendlePtOracle(address,address)": TypedContractEvent<NewPendlePtOracleEvent.InputTuple, NewPendlePtOracleEvent.OutputTuple, NewPendlePtOracleEvent.OutputObject>;
        NewPendlePtOracle: TypedContractEvent<NewPendlePtOracleEvent.InputTuple, NewPendlePtOracleEvent.OutputTuple, NewPendlePtOracleEvent.OutputObject>;
        "NewPythOracle(address,address)": TypedContractEvent<NewPythOracleEvent.InputTuple, NewPythOracleEvent.OutputTuple, NewPythOracleEvent.OutputObject>;
        NewPythOracle: TypedContractEvent<NewPythOracleEvent.InputTuple, NewPythOracleEvent.OutputTuple, NewPythOracleEvent.OutputObject>;
        "OwnershipTransferStarted(address,address)": TypedContractEvent<OwnershipTransferStartedEvent.InputTuple, OwnershipTransferStartedEvent.OutputTuple, OwnershipTransferStartedEvent.OutputObject>;
        OwnershipTransferStarted: TypedContractEvent<OwnershipTransferStartedEvent.InputTuple, OwnershipTransferStartedEvent.OutputTuple, OwnershipTransferStartedEvent.OutputObject>;
        "OwnershipTransferred(address,address)": TypedContractEvent<OwnershipTransferredEvent.InputTuple, OwnershipTransferredEvent.OutputTuple, OwnershipTransferredEvent.OutputObject>;
        OwnershipTransferred: TypedContractEvent<OwnershipTransferredEvent.InputTuple, OwnershipTransferredEvent.OutputTuple, OwnershipTransferredEvent.OutputObject>;
    };
}
